// MouseDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Mouse.h"
#include "MouseDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMouseDlg dialog



CMouseDlg::CMouseDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMouseDlg::IDD, pParent)
	, m_iPrevY(0)
	, m_iPrevX(0)
	, m_bCursor(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMouseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMouseDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_SETCURSOR()
END_MESSAGE_MAP()


// CMouseDlg message handlers

BOOL CMouseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	// Initialize the cursor to the arrow
	m_bCursor = FALSE;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMouseDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMouseDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMouseDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMouseDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	// Check to see if the left mouse button is down
	if ((nFlags & MK_LBUTTON) == MK_LBUTTON)
	{
		// Get the Device Context
		CClientDC dc(this);

		// Draw a line from the previous point to the current point
		dc.MoveTo(m_iPrevX, m_iPrevY);
		dc.LineTo(point.x, point.y);

		// Save the current point as the previous point
		m_iPrevX = point.x;
		m_iPrevY = point.y;
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CMouseDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	// Set the current point as the starting point
	m_iPrevX = point.x;
	m_iPrevY = point.y;

	CDialog::OnLButtonDown(nFlags, point);
}

void CMouseDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	char cChar;		// The current character being pressed
	HCURSOR hCursor = 0;	// The handle to the cursor to be displayed
	HCURSOR hPrevCursor = 0;	// The handle to the previous cursor

	// Convert the key pressed to a character
	cChar = char(nChar);

	// Is the character "A"
	if (cChar == 'A')
		// Load the arrow cursor
		hCursor = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
	// Is the character "B"
	if (cChar == 'B')
		// Load the I beam cursor
		hCursor = AfxGetApp()->LoadStandardCursor(IDC_IBEAM);
	// Is the character "C"
	if (cChar == 'C')
		// Load the hourglass cursor
		hCursor = AfxGetApp()->LoadStandardCursor(IDC_WAIT);

	// Is the character "X"
	if (cChar == 'X')
	{
		// Load the arrow cursor
		hCursor = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
		// Set the cursor flag
		m_bCursor = TRUE;
		// Set the screen cursor
		hPrevCursor = SetCursor(hCursor);
		// Destroy the previous cursor to free up the resources
		if (hPrevCursor)
			DestroyCursor(hPrevCursor);
		// Exit the application
		OnOK();
	}
	else
	{
		// Set the screen cursor
		if (hCursor)
		{
			hPrevCursor = SetCursor(hCursor);
			// Set the cursor flag
			m_bCursor = TRUE;
			// Destroy the previous cursor to free up the resources
			if (hPrevCursor)
				DestroyCursor(hPrevCursor);
		}
	}

	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

BOOL CMouseDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	// TODO: Add your message handler code here and/or call default
	if (m_bCursor)
		// return TRUE
		return TRUE;

	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}
