// TimersDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Timers.h"
#include "TimersDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTimersDlg dialog



CTimersDlg::CTimersDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTimersDlg::IDD, pParent)
	, m_sTime(_T(""))
	, m_iInterval(0)
	, m_sCount(_T(""))
	, m_iCount(0)
	, m_bPreventUpdate(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTimersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_STATICTIME, m_sTime);
	DDX_Text(pDX, IDC_INTERVAL, m_iInterval);
	DDV_MinMaxInt(pDX, m_iInterval, 1, 100000);
	DDX_Text(pDX, IDC_STATICCOUNT, m_sCount);
	DDX_Control(pDX, IDC_STARTTIME, m_cStartTime);
	DDX_Control(pDX, IDC_STOPTIMER, m_cStopTime);
}

BEGIN_MESSAGE_MAP(CTimersDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_INTERVAL, OnEnChangeInterval)
	ON_BN_CLICKED(IDC_STARTTIME, OnBnClickedStarttime)
	ON_BN_CLICKED(IDC_STOPTIMER, OnBnClickedStoptimer)
	ON_BN_CLICKED(IDC_EXIT, OnBnClickedExit)
END_MESSAGE_MAP()


// CTimersDlg message handlers

BOOL CTimersDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	// Initialize the counter interval
	m_iInterval = 100;

	// Update the dialog
	UpdateData(FALSE);

	// Start the clock timer
	SetTimer(ID_CLOCK_TIMER, 1000, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTimersDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTimersDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTimersDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTimersDlg::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	// Get the current time
	CTime curTime = CTime::GetCurrentTime();

	// Which timer triggered this event?
	switch (nIDEvent)
	{
		// The clock timer?
	case ID_CLOCK_TIMER:
		// Display the current time
		m_sTime = curTime.Format("%H:%M:%S");
		break;
		// The count timer?
	case ID_COUNT_TIMER:
		// Increment the count
		m_iCount++;
		// Format and display the count
		m_sCount.Format("%d", m_iCount);
		break;
	}

	if (!m_bPreventUpdate)
		// Update the dialog
		UpdateData(FALSE);

	CDialog::OnTimer(nIDEvent);
}

void CTimersDlg::OnEnChangeInterval()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	// Prevent updating the screen
	m_bPreventUpdate = TRUE;
	// Update the variables
	UpdateData(TRUE);
	// Allow updating the screen
	m_bPreventUpdate = FALSE;
}

void CTimersDlg::OnBnClickedStarttime()
{
	// TODO: Add your control notification handler code here
	// Prevent updating the screen
	m_bPreventUpdate = TRUE;
	// Update the variables
	UpdateData(TRUE);
	// Allow updating the screen
	m_bPreventUpdate = FALSE;
    // Prevent going any further if the value is out of range
    if ((m_iInterval < 1) || (m_iInterval > 100000))
        return;

	// Initialize the count
	m_iCount = 0;
	// Format the count for displaying
	m_sCount.Format("%d", m_iCount);

	// Update the dialog
	UpdateData(FALSE);
	// Start the timer
	SetTimer(ID_COUNT_TIMER, m_iInterval, NULL);

	// Enable the Stop Timer button
	m_cStopTime.EnableWindow(TRUE);
	// Disable the Start Timer button
	m_cStartTime.EnableWindow(FALSE);
}

void CTimersDlg::OnBnClickedStoptimer()
{
	// TODO: Add your control notification handler code here
	// Stop the timer
	KillTimer(ID_COUNT_TIMER);

	// Disable the Stop Timer button
	m_cStopTime.EnableWindow(FALSE);
	// Enable the Start Timer button
	m_cStartTime.EnableWindow(TRUE);
}

void CTimersDlg::OnBnClickedExit()
{
	// TODO: Add your control notification handler code here
	// Close the application
	OnOK();
}
