// TextFontsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TextFonts.h"
#include "TextFontsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTextFontsDlg dialog



CTextFontsDlg::CTextFontsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTextFontsDlg::IDD, pParent)
	, m_strDisplayText(_T(""))
	, m_strFontName(_T(""))
	, m_strSampText(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTextFontsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DISPLAYTEXT, m_ctlDisplayText);
	DDX_Text(pDX, IDC_DISPLAYTEXT, m_strDisplayText);
	DDX_Control(pDX, IDC_LFONTS, m_ctlFontList);
	DDX_LBString(pDX, IDC_LFONTS, m_strFontName);
	DDX_Text(pDX, IDC_ESAMPTEXT, m_strSampText);
}

BEGIN_MESSAGE_MAP(CTextFontsDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_EXIT, OnBnClickedExit)
	ON_EN_CHANGE(IDC_ESAMPTEXT, OnEnChangeEsamptext)
	ON_LBN_SELCHANGE(IDC_LFONTS, OnLbnSelchangeLfonts)
END_MESSAGE_MAP()


// CTextFontsDlg message handlers

BOOL CTextFontsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	// Fill the font list box
    FillFontList();

	// Initialize the text to be entered
    m_strSampText = "Testing";
    // Copy the text to the font sample area
    m_strDisplayText = m_strSampText;
    // Update the dialog
    UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTextFontsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTextFontsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTextFontsDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTextFontsDlg::OnBnClickedExit()
{
	// TODO: Add your control notification handler code here
	OnOK();
}

int CALLBACK MyEnumFontProc(LPENUMLOGFONTEX lpelf, NEWTEXTMETRICEX* lpntm, DWORD nFontType, long lParam)
{
	// Create a pointer to the dialog window
	CTextFontsDlg* pWnd = (CTextFontsDlg*) lParam;

	if (pWnd)
	{
		// Add the font name to the list box
		pWnd->m_ctlFontList.AddString(lpelf->elfLogFont.lfFaceName);
		// Return 1 to continue font enumeration
		return 1;
	}
	return 0;
}

void CTextFontsDlg::FillFontList(void)
{
	int iCurCount;            // The current font
    CString strCurFont;            // The current font name
    CString strPrevFont = "";    // The previous font name
    LOGFONT lf;

    lf.lfCharSet = DEFAULT_CHARSET;
    // Specify all fonts
    lf.lfFaceName[0] = NULL;
    // Must be zero unless Hebrew or Arabic
    lf.lfPitchAndFamily = 0;

    // Clear the list box
    m_ctlFontList.ResetContent();
    // Create a device context variable
    CClientDC dc (this);
    // Enumerate the font families
    ::EnumFontFamiliesEx((HDC) dc, &lf, (FONTENUMPROC) MyEnumFontProc, (LPARAM) this, 0);
    // Loop from the last entry in the list box to the first,
    // searching for and deleting the duplicate entries
    for (iCurCount = m_ctlFontList.GetCount(); iCurCount > 0; iCurCount--)
    {
        // Get the current font name
        m_ctlFontList.GetText((iCurCount - 1), strCurFont);
        // Is it the same as the previous font name?
        if (strCurFont == strPrevFont)
        {
            // If yes, then delete it
            m_ctlFontList.DeleteString((iCurCount - 1));
        }
        else
        {
            // Set the previous font name to the current font name
            strPrevFont = strCurFont;
        }
    }
}

void CTextFontsDlg::OnEnChangeEsamptext()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	// Update the variables with the dialog controls 
    UpdateData(TRUE);
    // Copy the current text to the font sample
    m_strDisplayText = m_strSampText;
    // Update the dialog with the variables
    UpdateData(FALSE);
}

void CTextFontsDlg::SetMyFont(void)
{
    CRect rRect;        // The rectangle of the display area

    // Has a font been selected?
    if (m_strFontName.GetLength() > 0)
    {
        // Get the dimensions of the font sample display area
        m_ctlDisplayText.GetWindowRect(&rRect);
        // Release the current font
        m_fSampFont.Detach();
        // Create the font to be used
        m_fSampFont.CreateFont((rRect.Height()- 5), 0, 0, 0, FW_NORMAL,
                0, 0, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,
                CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH |
                FF_DONTCARE, m_strFontName);

        // Set the font for the sample display area
        m_ctlDisplayText.SetFont(&m_fSampFont);
    }
}

void CTextFontsDlg::OnLbnSelchangeLfonts()
{
	// TODO: Add your control notification handler code here
    // Update the variables with the dialog controls
    UpdateData(TRUE);

    // Set the font for the sample
    SetMyFont();
}
