// GraphicsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Graphics.h"
#include "GraphicsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGraphicsDlg dialog



CGraphicsDlg::CGraphicsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphicsDlg::IDD, pParent)
	, m_iTool(0)
	, m_iShape(0)
	, m_iColor(0)
	, m_dlgPaint(0)
	, m_strBitmap(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGraphicsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RTPEN, m_iTool);
	DDX_Radio(pDX, IDC_RSLINE, m_iShape);
	DDX_Radio(pDX, IDC_RCBLACK, m_iColor);
}

BEGIN_MESSAGE_MAP(CGraphicsDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BEXIT, OnBnClickedBexit)
	ON_BN_CLICKED(IDC_RTPEN, OnRSelection)
	ON_BN_CLICKED(IDC_RTBRUSH, OnRSelection)
	ON_BN_CLICKED(IDC_RTBITMAP, OnRSelection)
	ON_BN_CLICKED(IDC_RSLINE, OnRSelection)
	ON_BN_CLICKED(IDC_RSSQUARE, OnRSelection)
	ON_BN_CLICKED(IDC_RSCIRCLE, OnRSelection)
	ON_BN_CLICKED(IDC_RCBLACK, OnRSelection)
	ON_BN_CLICKED(IDC_RCBLUE, OnRSelection)
	ON_BN_CLICKED(IDC_RCGREEN, OnRSelection)
	ON_BN_CLICKED(IDC_RCCYAN, OnRSelection)
	ON_BN_CLICKED(IDC_RCRED, OnRSelection)
	ON_BN_CLICKED(IDC_RCMAGENTA, OnRSelection)
	ON_BN_CLICKED(IDC_RCYELLOW, OnRSelection)
	ON_BN_CLICKED(IDC_RCWHITE, OnRSelection)
	ON_BN_CLICKED(IDC_BBITMAP, OnBnClickedBbitmap)
END_MESSAGE_MAP()


// CGraphicsDlg message handlers

BOOL CGraphicsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	// Initialize the variables and update the dialog window
    m_iColor = 0;
    m_iShape = 0;
    m_iTool = 0;
    UpdateData(FALSE);

    // Create the second dialog window
    m_dlgPaint.Create(IDD_PAINT_DLG, this);
    // Show the second dialog window
    m_dlgPaint.ShowWindow(SW_SHOW);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGraphicsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGraphicsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGraphicsDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CGraphicsDlg::OnBnClickedBexit()
{
	// TODO: Add your control notification handler code here
	OnOK();
}

void CGraphicsDlg::OnRSelection()
{
	// TODO: Add your control notification handler code here
	// Synchronize the data
    UpdateData(TRUE);
    // Repaint the second dialog
    m_dlgPaint.Invalidate();
}

void CGraphicsDlg::OnBnClickedBbitmap()
{
	// TODO: Add your control notification handler code here
	// Build a filter for use in the File Open dialog
    static char BASED_CODE szFilter[] = "JPEG Files (*.jpg)|*.jpg|Bitmap Files (*.bmp)|*.bmp||";    
    // Create the File Open dialog
    CFileDialog dlgFile(TRUE, ".jpg", m_strBitmap, 
        OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

    // Show the File Open dialog and capture the result
    if (dlgFile.DoModal() == IDOK)
    {
        // Get the filename selected
        m_strBitmap = dlgFile.GetPathName();
        //// Load the selected bitmap file
        //HBITMAP hBitmap = (HBITMAP) ::LoadImage(AfxGetInstanceHandle(),
        //    m_strBitmap, IMAGE_BITMAP, 0, 0, 
        //    LR_LOADFROMFILE | LR_CREATEDIBSECTION);

        //// Do we have a valid handle for the loaded image?
        //if (hBitmap)
        //{
        //    // Delete the current bitmap
        //    if (m_bmpBitmap.DeleteObject())
        //        // If there was a bitmap, detach it
        //        m_bmpBitmap.Detach();
        //    // Attach the currently loaded bitmap to the bitmap object
        //    m_bmpBitmap.Attach(hBitmap);
        //}
	    // Delete the current image
        m_bmpBitmap.Destroy();
        // Load the new image
        m_bmpBitmap.Load(m_strBitmap);

        // Invalidate the second dialog window
        m_dlgPaint.Invalidate();
    }
}
