#include "StdAfx.h"
#include "line.h"

IMPLEMENT_SERIAL (CLine, CObject, 1)

CLine::CLine(void)
: m_ptFrom(0)
, m_ptTo(0)
{
}

CLine::~CLine(void)
{
}

CLine::CLine(CPoint ptFrom, CPoint ptTo, COLORREF crColor)
{
	//Initialize the from and to points
	m_ptFrom = ptFrom;
    m_ptTo = ptTo;
	m_crColor = crColor;
}

void CLine::Draw(CDC* pDC)
{
	// Create a pen
    CPen lpen (PS_SOLID, 1, m_crColor);

    // Set the new pen as the drawing object
    CPen* pOldPen = pDC->SelectObject(&lpen);
	// Draw the line
    pDC->MoveTo(m_ptFrom);
    pDC->LineTo(m_ptTo);
    // Reset the previous pen
    pDC->SelectObject(pOldPen);
}

void CLine::Serialize(CArchive& ar)
{
	CObject::Serialize(ar);

    if (ar.IsStoring())
        ar << m_ptFrom << m_ptTo << (DWORD) m_crColor;
    else
        ar >> m_ptFrom >> m_ptTo >> (DWORD) m_crColor;
}
