// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "SDISquig.h"
#include "SDISquigDoc.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_COLORBAR, OnViewColorbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COLORBAR, OnUpdateViewColorbar)
	ON_CBN_SELCHANGE(IDC_CBWIDTH, OnSelChangeWidth)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_COLOR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// Add the color toolbar
    if (!CreateColorBar())
    {
        TRACE0("Failed to create color toolbar\n");
        return -1;      // fail to create
    }

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	// Enable docking for the color toolbar
    m_wndColorBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// Dock the Color toolbar
    DockControlBar(&m_wndColorBar);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers


void CMainFrame::OnViewColorbar()
{
	// TODO: Add your command handler code here
	// Toggle the color bar
    ShowControlBar(&m_wndColorBar, !m_wndColorBar.IsVisible(), FALSE);
    // Reshuffle the frame layout
    RecalcLayout();
}

void CMainFrame::OnUpdateViewColorbar(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	// Check the state of the color toolbar
    pCmdUI->SetCheck(m_wndColorBar.IsVisible());
}

BOOL CMainFrame::CreateColorBar(void)
{
	// Add the color toolbar
    int iTBCtlID;
    int i;

    // Create the color toolbar
    if (!m_wndColorBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | 
            WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_TOOLTIPS | 
            CBRS_FLYBY | CBRS_SIZE_DYNAMIC) || 
            !m_wndColorBar.LoadToolBar(IDR_TBCOLOR))
    {
        TRACE0("Failed to create toolbar\n");
        return FALSE;    // fail to create
    }
    // Find the Black button on the toolbar
    iTBCtlID = m_wndColorBar.CommandToIndex(ID_COLOR_BLACK);
    if (iTBCtlID >= 0)
    {
        // Loop through the buttons, setting them to act as radio buttons
        for (i = iTBCtlID; i < (iTBCtlID + 8); i++)
            m_wndColorBar.SetButtonStyle(i, TBBS_CHECKGROUP);
    }
    // Add the combo
    int nWidth = 100;
    int nHeight = 125;

    // Configure the combo place holder
    m_wndColorBar.SetButtonInfo(9, IDC_CBWIDTH, TBBS_SEPARATOR, nWidth);

    // Get the colorbar height
    CRect rect;
    m_wndColorBar.GetItemRect(9, &rect);
    rect.bottom = rect.top + nHeight;

    // Create the combo box
    m_ctlWidth.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | 
            CBS_DROPDOWNLIST, rect, &m_wndColorBar, IDC_CBWIDTH);

    // Fill the combo box
    CString strStyle;
    if (strStyle.LoadString(IDS_WIDTH_VERYTHIN))
        m_ctlWidth.AddString((LPCTSTR)strStyle);
    if (strStyle.LoadString(IDS_WIDTH_THIN))
        m_ctlWidth.AddString((LPCTSTR)strStyle);
    if (strStyle.LoadString(IDS_WIDTH_MEDIUM))
        m_ctlWidth.AddString((LPCTSTR)strStyle);
    if (strStyle.LoadString(IDS_WIDTH_THICK))
        m_ctlWidth.AddString((LPCTSTR)strStyle);
    if (strStyle.LoadString(IDS_WIDTH_VERYTHICK))
        m_ctlWidth.AddString((LPCTSTR)strStyle);

    // Select the first entry in the combo box
    m_ctlWidth.SetCurSel(0);

    return TRUE;
}

void CMainFrame::OnSelChangeWidth(void)
{
    // Get the new combo selection
    int iIndex = m_ctlWidth.GetCurSel();
    if (iIndex == CB_ERR)
        return;

    // Get the active document
    CSDISquigDoc* pDoc = (CSDISquigDoc*)GetActiveDocument();
    // Do we have a valid document?
    if (pDoc)
        // Set the new drawing width
        pDoc->SetWidth(iIndex);
}

void CMainFrame::UpdateWidthCB(int iIndex)
{
	// Set the new selection in the combo box
    m_ctlWidth.SetCurSel(iIndex);
}
