// SerializeView.cpp : implementation of the CSerializeView class
//

#include "stdafx.h"
#include "Serialize.h"

#include "SerializeDoc.h"
#include "SerializeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSerializeView

IMPLEMENT_DYNCREATE(CSerializeView, CFormView)

BEGIN_MESSAGE_MAP(CSerializeView, CFormView)
	ON_BN_CLICKED(IDC_BFIRST, OnBnClickedBfirst)
	ON_BN_CLICKED(IDC_BPREV, OnBnClickedBprev)
	ON_BN_CLICKED(IDC_BNEXT, OnBnClickedBnext)
	ON_BN_CLICKED(IDC_BLAST, OnBnClickedBlast)
	ON_BN_CLICKED(IDC_CBEMPLOYED, OnBnClickedCbemployed)
	ON_EN_CHANGE(IDC_ENAME, OnEnChangeEname)
	ON_EN_CHANGE(IDC_EAGE, OnEnChangeEage)
	ON_BN_CLICKED(IDC_RSINGLE, OnBnClickedRsingle)
	ON_BN_CLICKED(IDC_RMARRIED, OnBnClickedRsingle)
	ON_BN_CLICKED(IDC_RDIVORCED, OnBnClickedRsingle)
	ON_BN_CLICKED(IDC_RWIDOW, OnBnClickedRsingle)
END_MESSAGE_MAP()

// CSerializeView construction/destruction

CSerializeView::CSerializeView()
	: CFormView(CSerializeView::IDD)
	, m_sName(_T(""))
	, m_iAge(0)
	, m_iMaritalStatus(0)
	, m_bEmployed(FALSE)
	, m_sPosition(_T(""))
	, m_pCurPerson(NULL)
{
	// TODO: add construction code here

}

CSerializeView::~CSerializeView()
{
}

void CSerializeView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_ENAME, m_sName);
	DDX_Text(pDX, IDC_EAGE, m_iAge);
	DDX_Radio(pDX, IDC_RSINGLE, m_iMaritalStatus);
	DDX_Check(pDX, IDC_CBEMPLOYED, m_bEmployed);
	DDX_Text(pDX, IDC_SPOSITION, m_sPosition);
}

BOOL CSerializeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CSerializeView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
}


// CSerializeView diagnostics

#ifdef _DEBUG
void CSerializeView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSerializeView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CSerializeDoc* CSerializeView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSerializeDoc)));
	return (CSerializeDoc*)m_pDocument;
}
#endif //_DEBUG


// CSerializeView message handlers

void CSerializeView::PopulateView(void)
{
	// Get a pointer to the current document
    CSerializeDoc* pDoc = GetDocument();
    if (pDoc)
    {
        // Display the current record position in the set
        m_sPosition.Format("Record %d of %d", pDoc->GetCurRecordNbr(),
                pDoc->GetTotalRecords());
    }
    // Do we have a valid record object?
    if (m_pCurPerson)
    {
        // Yes, get all of the record values
        m_bEmployed = m_pCurPerson->GetEmployed();
        m_iAge = m_pCurPerson->GetAge();
        m_sName = m_pCurPerson->GetName();
        m_iMaritalStatus = m_pCurPerson->GetMaritalStatus();
    }
    // Update the display
    UpdateData(FALSE);
}

void CSerializeView::OnBnClickedBfirst()
{
	// TODO: Add your control notification handler code here
	// Get a pointer to the current document
    CSerializeDoc* pDoc = GetDocument();
    if (pDoc)
    {
        // Get the first record from the document
        m_pCurPerson = pDoc->GetFirstRecord();
        if (m_pCurPerson)
        {
            // Display the current record
            PopulateView();
        }
    }
}

void CSerializeView::OnBnClickedBprev()
{
	// TODO: Add your control notification handler code here
	// Get a pointer to the current document
    CSerializeDoc* pDoc = GetDocument();
    if (pDoc)
    {
        // Get the previous record from the document
        m_pCurPerson = pDoc->GetPrevRecord();
        if (m_pCurPerson)
        {
            // Display the current record
            PopulateView();
        }
    }
}

void CSerializeView::OnBnClickedBnext()
{
	// TODO: Add your control notification handler code here
	// Get a pointer to the current document
    CSerializeDoc* pDoc = GetDocument();
    if (pDoc)
    {
        // Get the next record from the document
        m_pCurPerson = pDoc->GetNextRecord();
        if (m_pCurPerson)
        {
            // Display the current record
            PopulateView();
        }
    }
}

void CSerializeView::OnBnClickedBlast()
{
	// TODO: Add your control notification handler code here
	// Get a pointer to the current document
    CSerializeDoc* pDoc = GetDocument();
    if (pDoc)
    {
        // Get the last record from the document
        m_pCurPerson = pDoc->GetLastRecord();
        if (m_pCurPerson)
        {
            // Display the current record
            PopulateView();
        }
    }
}

void CSerializeView::OnBnClickedCbemployed()
{
	// TODO: Add your control notification handler code here
	// Sync the data in the form with the variables
    UpdateData(TRUE);
    // If we have a valid person object, pass the data changes to it
    if (m_pCurPerson)
        m_pCurPerson->SetEmployed(m_bEmployed);
}

void CSerializeView::OnEnChangeEname()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	// Sync the data in the form with the variables
    UpdateData(TRUE);
    // If we have a valid person object, pass the data changes to it
    if (m_pCurPerson)
        m_pCurPerson->SetName(m_sName);
}

void CSerializeView::OnEnChangeEage()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	// Sync the data in the form with the variables
    UpdateData(TRUE);
    // If we have a valid person object, pass the data changes to it
    if (m_pCurPerson)
        m_pCurPerson->SetAge(m_iAge);
}

void CSerializeView::OnBnClickedRsingle()
{
	// TODO: Add your control notification handler code here
	// Sync the data in the form with the variables
    UpdateData(TRUE);
    // If we have a valid person object, pass the data changes to it
    if (m_pCurPerson)
        m_pCurPerson->SetMaritalStatus(m_iMaritalStatus);
}


void CSerializeView::NewDataSet(void)
{
	// Display the first record in the set
    OnBnClickedBfirst();
}
