// AdoDatabaseDoc.cpp : implementation of the CAdoDatabaseDoc class
//

#include "stdafx.h"
#include "AdoDatabase.h"

#include "AdoDatabaseDoc.h"
#include "AdoDatabaseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAdoDatabaseDoc

IMPLEMENT_DYNCREATE(CAdoDatabaseDoc, CDocument)

BEGIN_MESSAGE_MAP(CAdoDatabaseDoc, CDocument)
END_MESSAGE_MAP()


// CAdoDatabaseDoc construction/destruction

CAdoDatabaseDoc::CAdoDatabaseDoc()
: m_piAdoRecordBinding(NULL)
, m_strConnection(_T(""))
, m_strCmdText(_T(""))
{
	// TODO: add one-time construction code here

}

CAdoDatabaseDoc::~CAdoDatabaseDoc()
{
}

BOOL CAdoDatabaseDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	// Set the connection and SQL command strings
    m_strConnection = _T("Provider=MSDASQL.1;Data Source=STYVCDB");
    m_strCmdText = _T("select * from Addresses");

    // Initialize the Recordset and binding pointers
    m_ptrRs = NULL;
    m_piAdoRecordBinding = NULL;
    // Initialize the COM environment
    ::CoInitialize(NULL);
    try
    {
        // Create the recordset object
        m_ptrRs.CreateInstance(__uuidof(Recordset));

        // Open the recordset object
        m_ptrRs->Open((LPCTSTR)m_strCmdText, (LPCTSTR)m_strConnection, 
            adOpenDynamic, adLockOptimistic, adCmdUnknown);
        // Get a pointer to the record-binding interface
        if (FAILED(m_ptrRs->QueryInterface(__uuidof(IADORecordBinding), 
                    (LPVOID *)&m_piAdoRecordBinding)))
            _com_issue_error(E_NOINTERFACE);
        // Bind the record class to the recordset
        m_piAdoRecordBinding->BindToRecordset(&m_rsRecSet);

        // Get a pointer to the view
        POSITION pos = GetFirstViewPosition();
        CAdoDatabaseView* pView = (CAdoDatabaseView*)GetNextView(pos);
        if (pView)
            // Sync the data set with the form
            pView->RefreshBoundData();
    }
    // Any errors?
    catch (_com_error &e)
    {
        // Display the error
        GenerateError(e.Error(), e.Description());
    }

	return TRUE;
}




// CAdoDatabaseDoc serialization

void CAdoDatabaseDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


// CAdoDatabaseDoc diagnostics

#ifdef _DEBUG
void CAdoDatabaseDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAdoDatabaseDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CAdoDatabaseDoc commands

CCustomRs* CAdoDatabaseDoc::GetRecSet(void)
{
	// Return a pointer to the record object
    return &m_rsRecSet;
}

void CAdoDatabaseDoc::GenerateError(HRESULT hr, PWSTR pwszDescription)
{
	CString strError;
    // Format and display the error message
    strError.Format("Run-time error '%d (%x)'", hr, hr);
    strError += "\n\n";
    strError += pwszDescription;

    AfxMessageBox(strError);
}

void CAdoDatabaseDoc::DeleteContents()
{
	// TODO: Add your specialized code here and/or call the base class
	// Close the recordset
    if (m_ptrRs)
        m_ptrRs->Close();
    // Do we have a valid pointer to the record binding?
    if (m_piAdoRecordBinding)
        // Release it
        m_piAdoRecordBinding->Release();
    // Set the recordset pointer to NULL
    m_ptrRs = NULL;

    // Shut down the COM environment
    CoUninitialize();
	CDocument::DeleteContents();
}

void CAdoDatabaseDoc::MoveFirst(void)
{
    try
    {
        // Update the current record
        m_piAdoRecordBinding->Update(&m_rsRecSet);
        // Move to the first record
        m_ptrRs->MoveFirst();
    }
    // Any errors?
    catch (_com_error &e)
    {
        // Generate the error message
        GenerateError(e.Error(), e.Description());
    }
}

void CAdoDatabaseDoc::MovePrevious(void)
{
    try
    {
        // Update the current record
        m_piAdoRecordBinding->Update(&m_rsRecSet);
        // Move to the previous record
        m_ptrRs->MovePrevious();
    }
    // Any errors?
    catch (_com_error &e)
    {
        // Generate the error message
        GenerateError(e.Error(), e.Description());
    }
}

void CAdoDatabaseDoc::MoveNext(void)
{
    try
    {
        // Update the current record
        m_piAdoRecordBinding->Update(&m_rsRecSet);
        // Move to the next record
        m_ptrRs->MoveNext();
    }
    // Any errors?
    catch (_com_error &e)
    {
        // Generate the error message
        GenerateError(e.Error(), e.Description());
    }
}

void CAdoDatabaseDoc::MoveLast(void)
{
    try
    {
        // Update the current record
        m_piAdoRecordBinding->Update(&m_rsRecSet);
        // Move to the last record
        m_ptrRs->MoveLast();
    }
    // Any errors?
    catch (_com_error &e)
    {
        // Generate the error message
        GenerateError(e.Error(), e.Description());
    }
}

void CAdoDatabaseDoc::AddNew(void)
{
	try
    {
        // Update the current record
        m_piAdoRecordBinding->Update(&m_rsRecSet);
        // Can we add a new record?
        if (m_ptrRs->Supports(adAddNew))
        {
            // Create a blank record
            CreateBlankRecord();
            // Add the blank record
            m_piAdoRecordBinding->AddNew(&m_rsRecSet);
            // Move to the last record
            m_ptrRs->MoveLast();
        }
    }
    // Any errors?
    catch (_com_error &e)
    {
        // Generate an error message
        GenerateError(e.Error(), e.Description());
    }
}

void CAdoDatabaseDoc::CreateBlankRecord(void)
{
	// Set each of the values in the record object
    m_rsRecSet.m_lAddressID = 0;
    strcpy(m_rsRecSet.m_szFirstName, " ");
    strcpy(m_rsRecSet.m_szLastName, " ");
    strcpy(m_rsRecSet.m_szSpouseName, " ");
    strcpy(m_rsRecSet.m_szAddress, " ");
    strcpy(m_rsRecSet.m_szCity, " ");
    strcpy(m_rsRecSet.m_szStateOrProvince, " ");
    strcpy(m_rsRecSet.m_szPostalCode, " ");
    strcpy(m_rsRecSet.m_szCountry, " ");
    strcpy(m_rsRecSet.m_szEmailAddress, " ");
    strcpy(m_rsRecSet.m_szHomePhone, " ");
    strcpy(m_rsRecSet.m_szWorkPhone, " ");
    strcpy(m_rsRecSet.m_szWorkExtension, " ");
    strcpy(m_rsRecSet.m_szFaxNumber, " ");
    m_rsRecSet.m_dtBirthdate = NULL;
    m_rsRecSet.m_bSendCard = VARIANT_FALSE;
    strcpy(m_rsRecSet.m_szNotes, " ");
}

void CAdoDatabaseDoc::Delete(void)
{
	try
    {
        // Update the current record
        m_piAdoRecordBinding->Update(&m_rsRecSet);
        // Can we delete a record?
        if (m_ptrRs->Supports(adDelete))
        {
            // Make sure the user wants to delete this record
            if (AfxMessageBox(
                    "Are you sure you want to delete this record?",
                    MB_YESNO | MB_ICONQUESTION) == IDYES)
            {
                // Delete the record
                m_ptrRs->Delete(adAffectCurrent);
                // Move to the previous record
                m_ptrRs->MovePrevious();
            }
        }
    }
    // Any errors?
    catch (_com_error &e)
    {
        // Generate an error message
        GenerateError(e.Error(), e.Description());
    }
}
