// AdoDatabaseView.cpp : implementation of the CAdoDatabaseView class
//

#include "stdafx.h"
#include "AdoDatabase.h"

#include "AdoDatabaseDoc.h"
#include "AdoDatabaseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAdoDatabaseView

IMPLEMENT_DYNCREATE(CAdoDatabaseView, CFormView)

BEGIN_MESSAGE_MAP(CAdoDatabaseView, CFormView)
	ON_COMMAND(ID_DATA_FIRST, OnDataFirst)
	ON_COMMAND(ID_DATA_PREVIOUS, OnDataPrevious)
	ON_COMMAND(ID_DATA_NEXT, OnDataNext)
	ON_COMMAND(ID_DATA_LAST, OnDataLast)
	ON_COMMAND(ID_DATA_NEW, OnDataNew)
	ON_COMMAND(ID_DATA_DELETECURRENT, OnDataDeletecurrent)
END_MESSAGE_MAP()

// CAdoDatabaseView construction/destruction

CAdoDatabaseView::CAdoDatabaseView()
	: CFormView(CAdoDatabaseView::IDD)
	, m_lAddressID(0)
	, m_strFirstName(_T(""))
	, m_strLastName(_T(""))
	, m_strSpouseName(_T(""))
	, m_strAddress(_T(""))
	, m_strCity(_T(""))
	, m_strStateOrProvince(_T(""))
	, m_strPostalCode(_T(""))
	, m_strCountry(_T(""))
	, m_strEmailAddress(_T(""))
	, m_strHomePhone(_T(""))
	, m_strWorkPhone(_T(""))
	, m_strWorkExtension(_T(""))
	, m_strFaxNumber(_T(""))
	, m_oledtBirthdate(COleDateTime::GetCurrentTime())
	, m_bSendCard(FALSE)
	, m_strNotes(_T(""))
{
	// TODO: add construction code here

}

CAdoDatabaseView::~CAdoDatabaseView()
{
}

void CAdoDatabaseView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EADDRESSID, m_lAddressID);
	DDX_Text(pDX, IDC_EFIRSTNAME, m_strFirstName);
	DDX_Text(pDX, IDC_ELASTNAME, m_strLastName);
	DDX_Text(pDX, IDC_ESPOUSENAME, m_strSpouseName);
	DDX_Text(pDX, IDC_EADDRESS, m_strAddress);
	DDX_Text(pDX, IDC_ECITY, m_strCity);
	DDX_Text(pDX, IDC_ESTATEORPROVINCE, m_strStateOrProvince);
	DDX_Text(pDX, IDC_EPOSTALCODE, m_strPostalCode);
	DDX_Text(pDX, IDC_ECOUNTRY, m_strCountry);
	DDX_Text(pDX, IDC_EEMAILADDRESS, m_strEmailAddress);
	DDX_Text(pDX, IDC_EHOMEPHONE, m_strHomePhone);
	DDX_Text(pDX, IDC_EWORKPHONE, m_strWorkPhone);
	DDX_Text(pDX, IDC_EWORKEXTENSION, m_strWorkExtension);
	DDX_Text(pDX, IDC_EFAXNUMBER, m_strFaxNumber);
	DDX_Text(pDX, IDC_EBIRTHDATE, m_oledtBirthdate);
	DDX_Check(pDX, IDC_CBSENDCARD, m_bSendCard);
	DDX_Text(pDX, IDC_ENOTES, m_strNotes);
}

BOOL CAdoDatabaseView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CAdoDatabaseView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
}


// CAdoDatabaseView diagnostics

#ifdef _DEBUG
void CAdoDatabaseView::AssertValid() const
{
	CFormView::AssertValid();
}

void CAdoDatabaseView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CAdoDatabaseDoc* CAdoDatabaseView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAdoDatabaseDoc)));
	return (CAdoDatabaseDoc*)m_pDocument;
}
#endif //_DEBUG


// CAdoDatabaseView message handlers

void CAdoDatabaseView::RefreshBoundData(void)
{
	CCustomRs* pRs;
    // Get a pointer to the document object
    pRs = GetDocument()->GetRecSet();

    // Is the field OK
    if (adFldOK == pRs->lAddressIDStatus)
        // Copy the value
        m_lAddressID = pRs->m_lAddressID;
    else
        // Otherwise, set the value to 0
        m_lAddressID = 0;
    // Is the field OK
    if (adFldOK == pRs->lFirstNameStatus)
        // Copy the value
        m_strFirstName = pRs->m_szFirstName;
    else
        // Otherwise, set the value to 0
        m_strFirstName = _T("");
    // Is the field OK
    if (adFldOK == pRs->lLastNameStatus)
        // Copy the value
        m_strLastName = pRs->m_szLastName;
    else
        // Otherwise, set the value to 0
        m_strLastName = _T("");
    // Is the field OK
    if (adFldOK == pRs->lSpouseNameStatus)
        // Copy the value
        m_strSpouseName = pRs->m_szSpouseName;
    else
        // Otherwise, set the value to 0
        m_strSpouseName = _T("");
    // Is the field OK
    if (adFldOK == pRs->lAddressStatus)
        // Copy the value
        m_strAddress = pRs->m_szAddress;
    else
        // Otherwise, set the value to 0
        m_strAddress = _T("");
    // Is the field OK
    if (adFldOK == pRs->lCityStatus)
        // Copy the value
        m_strCity = pRs->m_szCity;
    else
        // Otherwise, set the value to 0
        m_strCity = _T("");
    // Is the field OK
    if (adFldOK == pRs->lStateOrProvinceStatus)
        // Copy the value
        m_strStateOrProvince = pRs->m_szStateOrProvince;
    else
        // Otherwise, set the value to 0
        m_strStateOrProvince = _T("");
    // Is the field OK
    if (adFldOK == pRs->lPostalCodeStatus)
        // Copy the value
        m_strPostalCode = pRs->m_szPostalCode;
    else
        // Otherwise, set the value to 0
        m_strPostalCode = _T("");
    // Is the field OK
    if (adFldOK == pRs->lCountryStatus)
        // Copy the value
        m_strCountry = pRs->m_szCountry;
    else
        // Otherwise, set the value to 0
        m_strCountry = _T("");
    // Is the field OK
    if (adFldOK == pRs->lEmailAddressStatus)
        // Copy the value
        m_strEmailAddress = pRs->m_szEmailAddress;
    else
        // Otherwise, set the value to 0
        m_strEmailAddress = _T("");
    // Is the field OK
    if (adFldOK == pRs->lHomePhoneStatus)
        // Copy the value
        m_strHomePhone = pRs->m_szHomePhone;
    else
        // Otherwise, set the value to 0
        m_strHomePhone = _T("");
    // Is the field OK
    if (adFldOK == pRs->lWorkPhoneStatus)
        // Copy the value
        m_strWorkPhone = pRs->m_szWorkPhone;
    else
        // Otherwise, set the value to 0
        m_strWorkPhone = _T("");
    // Is the field OK
    if (adFldOK == pRs->lWorkExtensionStatus)
        // Copy the value
        m_strWorkExtension = pRs->m_szWorkExtension;
    else
        // Otherwise, set the value to 0
        m_strWorkExtension = _T("");
    // Is the field OK
    if (adFldOK == pRs->lFaxNumberStatus)
        // Copy the value
        m_strFaxNumber = pRs->m_szFaxNumber;
    else
        // Otherwise, set the value to 0
        m_strFaxNumber = _T("");
    // Is the field OK
    if (adFldOK == pRs->lBirthdateStatus)
        // Copy the value
        m_oledtBirthdate = pRs->m_dtBirthdate;
    else
        // Otherwise, set the value to 0
        m_oledtBirthdate = 0L;
    // Is the field OK
    if (adFldOK == pRs->lSendCardStatus)
        // Copy the value
        m_bSendCard = VARIANT_FALSE == pRs->m_bSendCard ? FALSE : TRUE;
    else
        // Otherwise, set the value to 0
        m_bSendCard = FALSE;
    // Is the field OK
    if (adFldOK == pRs->lNotesStatus)
        // Copy the value
        m_strNotes = pRs->m_szNotes;
    else
        // Otherwise, set the value to 0
        m_strNotes = _T("");

    // Sync the data with the controls
    UpdateData(FALSE);
}

void CAdoDatabaseView::UpdateBoundData(void)
{
	CCustomRs* pRs;
    // Get a pointer to the document
    pRs = GetDocument()->GetRecSet();

    // Sync the controls with the variables
    UpdateData(TRUE);
    // Has the field changed? If so, copy the value back
    if (m_lAddressID != pRs->m_lAddressID)
        pRs->m_lAddressID = m_lAddressID;
    // Has the field changed? If so, copy the value back
    if (m_strFirstName != pRs->m_szFirstName)
        strcpy(pRs->m_szFirstName, (LPCTSTR)m_strFirstName);
    // Has the field changed? If so, copy the value back
    if (m_strLastName != pRs->m_szLastName)
        strcpy(pRs->m_szLastName, (LPCTSTR)m_strLastName);
    // Has the field changed? If so, copy the value back
    if (m_strSpouseName != pRs->m_szSpouseName)
        strcpy(pRs->m_szSpouseName, (LPCTSTR)m_strSpouseName);
    // Has the field changed? If so, copy the value back
    if (m_strAddress != pRs->m_szAddress)
        strcpy(pRs->m_szAddress, (LPCTSTR)m_strAddress);
    // Has the field changed? If so, copy the value back
    if (m_strCity != pRs->m_szCity)
        strcpy(pRs->m_szCity, (LPCTSTR)m_strCity);
    // Has the field changed? If so, copy the value back
    if (m_strStateOrProvince != pRs->m_szStateOrProvince)
        strcpy(pRs->m_szStateOrProvince, (LPCTSTR)m_strStateOrProvince);
    // Has the field changed? If so, copy the value back
    if (m_strPostalCode != pRs->m_szPostalCode)
        strcpy(pRs->m_szPostalCode, (LPCTSTR)m_strPostalCode);
    // Has the field changed? If so, copy the value back
    if (m_strCountry != pRs->m_szCountry)
        strcpy(pRs->m_szCountry, (LPCTSTR)m_strCountry);
    // Has the field changed? If so, copy the value back
    if (m_strEmailAddress != pRs->m_szEmailAddress)
        strcpy(pRs->m_szEmailAddress, (LPCTSTR)m_strEmailAddress);
    // Has the field changed? If so, copy the value back
    if (m_strHomePhone != pRs->m_szHomePhone)
        strcpy(pRs->m_szHomePhone, (LPCTSTR)m_strHomePhone);
    // Has the field changed? If so, copy the value back
    if (m_strWorkPhone != pRs->m_szWorkPhone)
        strcpy(pRs->m_szWorkPhone, (LPCTSTR)m_strWorkPhone);
    // Has the field changed? If so, copy the value back
    if (m_strWorkExtension != pRs->m_szWorkExtension)
        strcpy(pRs->m_szWorkExtension, (LPCTSTR)m_strWorkExtension);
    // Has the field changed? If so, copy the value back
    if (m_strFaxNumber != pRs->m_szFaxNumber)
        strcpy(pRs->m_szFaxNumber, (LPCTSTR)m_strFaxNumber);
    // Has the field changed? If so, copy the value back
    if (((DATE)m_oledtBirthdate) != pRs->m_dtBirthdate)
        pRs->m_dtBirthdate = (DATE)m_oledtBirthdate;
    // Has the field changed? If so, copy the value back
    if (m_bSendCard == TRUE)
        pRs->m_bSendCard = VARIANT_TRUE;
    else
        pRs->m_bSendCard = VARIANT_FALSE;
    // Has the field changed? If so, copy the value back
    if (m_strNotes != pRs->m_szNotes)
        strcpy(pRs->m_szNotes, (LPCTSTR)m_strNotes);
}

void CAdoDatabaseView::OnDataFirst()
{
	// TODO: Add your command handler code here
	// Update the current record
    UpdateBoundData();
    // Navigate to the first record
    GetDocument()->MoveFirst();
    // Refresh the form with the new record's data
    RefreshBoundData();
}

void CAdoDatabaseView::OnDataPrevious()
{
	// TODO: Add your command handler code here
	// Update the current record
    UpdateBoundData();
    // Navigate to the previous record
    GetDocument()->MovePrevious();
    // Refresh the form with the new record's data
    RefreshBoundData();
}

void CAdoDatabaseView::OnDataNext()
{
	// TODO: Add your command handler code here
	// Update the current record
    UpdateBoundData();
    // Navigate to the next record
    GetDocument()->MoveNext();
    // Refresh the form with the new record's data
    RefreshBoundData();
}

void CAdoDatabaseView::OnDataLast()
{
	// TODO: Add your command handler code here
	// Update the current record
    UpdateBoundData();
    // Navigate to the last record
    GetDocument()->MoveLast();
    // Refresh the form with the new record's data
    RefreshBoundData();
}

void CAdoDatabaseView::OnDataNew()
{
	// TODO: Add your command handler code here
	// Update the current record
    UpdateBoundData();
    // Add a new record
    GetDocument()->AddNew();
    // Refresh the form with the new record's data
    RefreshBoundData();
}

void CAdoDatabaseView::OnDataDeletecurrent()
{
	// TODO: Add your command handler code here
	// Update the current record
    UpdateBoundData();
    // Delete the current record
    GetDocument()->Delete();
    // Refresh the form with the new record's data
    RefreshBoundData();
}
