// SquiggleCtrl.cpp : Implementation of the CSquiggleCtrl ActiveX Control class.

#include "stdafx.h"
#include "Squiggle.h"
#include "SquiggleCtrl.h"
#include "SquigglePropPage.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(CSquiggleCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(CSquiggleCtrl, COleControl)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(CSquiggleCtrl, COleControl)
	DISP_FUNCTION_ID(CSquiggleCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
	DISP_PROPERTY_EX_ID(CSquiggleCtrl, "SquiggleLength", dispidSquiggleLength, GetSquiggleLength, SetSquiggleLength, VT_I2)
	DISP_PROPERTY_EX_ID(CSquiggleCtrl, "NumberSquiggles", dispidNumberSquiggles, GetNumberSquiggles, SetNumberSquiggles, VT_I2)
	DISP_PROPERTY_NOTIFY_ID(CSquiggleCtrl, "KeepCurrentDrawing", dispidKeepCurrentDrawing, m_KeepCurrentDrawing, OnKeepCurrentDrawingChanged, VT_BOOL)
	DISP_STOCKFUNC_DOCLICK()
	DISP_FUNCTION_ID(CSquiggleCtrl, "LoadDrawing", dispidLoadDrawing, LoadDrawing, VT_BOOL, VTS_BSTR)
END_DISPATCH_MAP()



// Event map

BEGIN_EVENT_MAP(CSquiggleCtrl, COleControl)
	EVENT_CUSTOM_ID("FileLoaded", eventidFileLoaded, FileLoaded, VTS_NONE)
END_EVENT_MAP()



// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CSquiggleCtrl, 1)
	PROPPAGEID(CSquigglePropPage::guid)
END_PROPPAGEIDS(CSquiggleCtrl)



// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CSquiggleCtrl, "SQUIGGLE.SquiggleCtrl.1",
	0x61845ea9, 0xdbb5, 0x4167, 0x8c, 0x6, 0x7b, 0xfc, 0xba, 0xd3, 0x66, 0x29)



// Type library ID and version

IMPLEMENT_OLETYPELIB(CSquiggleCtrl, _tlid, _wVerMajor, _wVerMinor)



// Interface IDs

const IID BASED_CODE IID_DSquiggle =
		{ 0xD4D764BC, 0x6003, 0x42E4, { 0x98, 0xF6, 0x92, 0x99, 0x89, 0xC, 0xB, 0xA5 } };
const IID BASED_CODE IID_DSquiggleEvents =
		{ 0x2037A27B, 0x8B03, 0x48AC, { 0x83, 0xA5, 0x7A, 0x3A, 0xCE, 0x46, 0x3B, 0x1E } };



// Control type information

static const DWORD BASED_CODE _dwSquiggleOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CSquiggleCtrl, IDS_SQUIGGLE, _dwSquiggleOleMisc)



// CSquiggleCtrl::CSquiggleCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CSquiggleCtrl

BOOL CSquiggleCtrl::CSquiggleCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_SQUIGGLE,
			IDB_SQUIGGLE,
			afxRegApartmentThreading,
			_dwSquiggleOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}



// CSquiggleCtrl::CSquiggleCtrl - Constructor

CSquiggleCtrl::CSquiggleCtrl()
: m_bGenNewDrawing(TRUE)
, m_KeepCurrentDrawing(FALSE)
{
	InitializeIIDs(&IID_DSquiggle, &IID_DSquiggleEvents);
	// TODO: Initialize your control's instance data here.
}



// CSquiggleCtrl::~CSquiggleCtrl - Destructor

CSquiggleCtrl::~CSquiggleCtrl()
{
	// TODO: Cleanup your control's instance data here.
}



// CSquiggleCtrl::OnDraw - Drawing function

void CSquiggleCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
//	pdc->Ellipse(rcBounds);
	// Do we need to generate a new drawing?
    if (m_bGenNewDrawing)
    {
        // Set the drawing area for the new drawing
        m_maDrawing.SetRect(rcBounds);
        // Clear out the old drawing
        m_maDrawing.ClearDrawing();
        // Generate the new drawing
        m_maDrawing.NewDrawing();
        // Reset the control flag
        m_bGenNewDrawing = FALSE;
    }
    // Draw the squiggle drawing
    m_maDrawing.Draw(pdc);
}



// CSquiggleCtrl::DoPropExchange - Persistence support

void CSquiggleCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
}



// CSquiggleCtrl::OnResetState - Reset control to default state

void CSquiggleCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}



// CSquiggleCtrl::AboutBox - Display an "About" box to the user

void CSquiggleCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_SQUIGGLE);
	dlgAbout.DoModal();
}



// CSquiggleCtrl message handlers

SHORT CSquiggleCtrl::GetSquiggleLength(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here
	// Return the result from the GetLength function
	return m_maDrawing.GetLength();
}

void CSquiggleCtrl::SetSquiggleLength(SHORT newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here
	// Set the new length value
	m_maDrawing.SetLength(newVal);

	SetModifiedFlag();
}

SHORT CSquiggleCtrl::GetNumberSquiggles(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here
	// Return the result from the GetLength function
	return m_maDrawing.GetSegments();
}

void CSquiggleCtrl::SetNumberSquiggles(SHORT newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here
	// Set the new length value
	m_maDrawing.SetSegments(newVal);

	SetModifiedFlag();
}

void CSquiggleCtrl::OnKeepCurrentDrawingChanged(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your property handler code here

	SetModifiedFlag();
}

void CSquiggleCtrl::OnClick(USHORT iButton)
{
	// TODO: Add your specialized code here and/or call the base class
	// Can we generate a new drawing?
	if (!m_KeepCurrentDrawing)
    {
        // Set the flag so a new drawing will be generated
        m_bGenNewDrawing = TRUE;
        // Invalidate the control to trigger the OnDraw function
        Invalidate();
    }
	COleControl::OnClick(iButton);
}

BOOL CSquiggleCtrl::DestroyWindow()
{
	// TODO: Add your specialized code here and/or call the base class
    // Clear the drawing
    m_maDrawing.ClearDrawing();
	return COleControl::DestroyWindow();
}

VARIANT_BOOL CSquiggleCtrl::LoadDrawing(LPCTSTR sFileName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// TODO: Add your dispatch handler code here
	try
	{
        // Create a CFile object
        CFile fFile(sFileName, CFile::modeRead);
        // Create a CArchive object to load the file
        CArchive lArchive(&fFile, CArchive::load);
        // Load the file
        m_maDrawing.Serialize(lArchive);
        // Make sure that the loaded drawing won't be overwritten
        m_bGenNewDrawing = FALSE;
        // Draw the loaded drawing
        Invalidate();
	    // Fire the FileLoaded event
		FileLoaded();
    }
    catch (CFileException* perr)
    {
        // Report the error
        perr->ReportError();
        // Delete the exception
        perr->Delete();
        return VARIANT_FALSE;
    }
	return VARIANT_TRUE;
}
