#pragma once
#include "modart.h"

// SquiggleCtrl.h : Declaration of the CSquiggleCtrl ActiveX Control class.


// CSquiggleCtrl : See SquiggleCtrl.cpp for implementation.

class CSquiggleCtrl : public COleControl
{
	DECLARE_DYNCREATE(CSquiggleCtrl)

// Constructor
public:
	CSquiggleCtrl();

// Overrides
public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();

// Implementation
protected:
	~CSquiggleCtrl();

	DECLARE_OLECREATE_EX(CSquiggleCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CSquiggleCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CSquiggleCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CSquiggleCtrl)		// Type name and misc status

// Message maps
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
		eventidFileLoaded = 1L,		dispidLoadDrawing = 4L,		dispidKeepCurrentDrawing = 3,		dispidNumberSquiggles = 2,		dispidSquiggleLength = 1
	};
private:
	CModArt m_maDrawing;
protected:
	SHORT GetSquiggleLength(void);
	void SetSquiggleLength(SHORT newVal);
	SHORT GetNumberSquiggles(void);
	void SetNumberSquiggles(SHORT newVal);
	void OnKeepCurrentDrawingChanged(void);
	VARIANT_BOOL m_KeepCurrentDrawing;
private:
	BOOL m_bGenNewDrawing;
public:
	virtual void OnClick(USHORT iButton);
	virtual BOOL DestroyWindow();
protected:
	VARIANT_BOOL LoadDrawing(LPCTSTR sFileName);

	void FileLoaded(void)
	{
		FireEvent(eventidFileLoaded, EVENT_PARAM(VTS_NONE));
	}
};

