#pragma once
#include "afx.h"
#include "atltypes.h"

class CSpinner :
	public CObject
{
public:
	CSpinner(void);
	~CSpinner(void);
	BOOL* GetContinue() { return m_pbContinue;}
	void SetContinue(BOOL* pbContinue) { m_pbContinue = pbContinue;}
    CWnd* GetViewWnd() { return m_pViewWnd;}
    void SetViewWnd(CWnd* pWnd) { m_pViewWnd = pWnd;}
    void SetLength(int iLength) { m_iRadius = iLength;}
    void SetPoint(CPoint ptPoint) { m_ptCenter = ptPoint;}

private:
	// The current color from the color table
	int m_iColor;
	// The position in the rotation around the wheel
	int m_iMinute;
	// The radius (size) of the wheel
	int m_iRadius;
	// The center point of the wheel
	CPoint m_ptCenter;
	// The color table with all of the colors to be drawn in the color wheel
	static COLORREF m_crColors[8];
	// A pointer to the view object
	CWnd* m_pViewWnd;
    // A pointer to the check box variable that specifies whether
    // this thread should be running
	BOOL* m_pbContinue;
public:
	void Draw(void);
};
