// TaskingDoc.cpp : implementation of the CTaskingDoc class
//

#include "stdafx.h"
#include "Tasking.h"

#include "TaskingDoc.h"
#include "TaskingView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTaskingDoc

IMPLEMENT_DYNCREATE(CTaskingDoc, CDocument)

BEGIN_MESSAGE_MAP(CTaskingDoc, CDocument)
END_MESSAGE_MAP()


// CTaskingDoc construction/destruction

CTaskingDoc::CTaskingDoc()
{
	// TODO: add one-time construction code here

}

CTaskingDoc::~CTaskingDoc()
{
}

BOOL CTaskingDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	// Initialize the spinners
	InitSpinners();

	return TRUE;
}




// CTaskingDoc serialization

void CTaskingDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


// CTaskingDoc diagnostics

#ifdef _DEBUG
void CTaskingDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTaskingDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CTaskingDoc commands

void CTaskingDoc::CalcPoint(int iID, CSpinner* pSpin)
{
    RECT rWndRect;
    CPoint ptPos;
    int iLength;
    CTaskingView *pWnd;

    // Get a pointer to the view window
    pWnd = (CTaskingView*)pSpin->GetViewWnd();
    // Get the display area rectangle
    pWnd->GetClientRect(&rWndRect);
    // Calculate the size of the spinners
    iLength = rWndRect.right / 6;
    // Which spinner are we placing?
    switch (iID)
    {
    case 0:    // Position the first spinner
        ptPos.x = (rWndRect.right / 4) - iLength;
        ptPos.y = (rWndRect.bottom / 4) - iLength;
        break;
    case 1:    // Position the second spinner
        ptPos.x = ((rWndRect.right / 4) * 3) - iLength;
        ptPos.y = (rWndRect.bottom / 4) - iLength;
        break;
    case 2:    // Position the third spinner
        ptPos.x = (rWndRect.right / 4) - iLength;
        ptPos.y = ((rWndRect.bottom / 4) * 3) - (long)(iLength * 1.25);
        break;
    case 3:    // Position the fourth spinner
        ptPos.x = ((rWndRect.right / 4) * 3) - iLength;
        ptPos.y = ((rWndRect.bottom / 4) * 3) - (long)(iLength * 1.25);
        break;
    }
    // Set the size of the spinner
    pSpin->SetLength(iLength);
    // Set the location of the spinner
    pSpin->SetPoint(ptPos);
}

void CTaskingDoc::InitSpinners(void)
{
    int i;

    // Get the position of the view
    POSITION pos = GetFirstViewPosition();
    // Did we get a valid position?
    if (pos != NULL)
    {
        // Get a pointer to the view
        CView* pView = GetNextView(pos);

        // Loop through the spinners
        for (i = 0; i < 4; i++)
        {
            // Set the pointer to the view
            m_cSpin[i].SetViewWnd(pView);
            // Initialize the pointer to the continuation indicator
            m_cSpin[i].SetContinue(NULL);
            switch (i)
            {
            case 1:    
                // Set the pointer to the first thread continuation indicator
                m_cSpin[i].SetContinue(&((CTaskingView*)pView)->m_bThread1);
                break;
            case 3:    
                // Set the pointer to the second thread continuation indicator
                m_cSpin[i].SetContinue(&((CTaskingView*)pView)->m_bThread2);
                break;
            }
            // Calculate the location of the spinner
            CalcPoint(i, &m_cSpin[i]);
        }
    }
}

void CTaskingDoc::DoSpin(int iIndex)
{
    // Spin the Spinner
    m_cSpin[iIndex].Draw();
}

UINT CTaskingDoc::ThreadFunc(LPVOID pParam)
{
    // Convert the argument to a pointer to the
    // spinner for this thread
    CSpinner* pSpin = (CSpinner*)pParam;
    // Get a pointer to the continuation flag
    BOOL* pbContinue = pSpin->GetContinue();

    // Loop while the continue flag is true
    while (*pbContinue)
        // Spin the spinner
        pSpin->Draw();
    // End thread
    AfxEndThread(0, TRUE);
    return 0;
}

void CTaskingDoc::SuspendSpinner(int iIndex, bool bRun)
{
    // if suspending the thread
    if (!bRun)
    {
        // Is the pointer for the thread valid?
        if (m_pSpinThread[iIndex])
        {
            // Get the handle for the thread
            HANDLE hThread = m_pSpinThread[iIndex]->m_hThread;
            // Wait for the thread to die
            ::WaitForSingleObject (hThread, INFINITE);
        }
    }
    else    // We are running the thread
    {
        int iSpnr;
        // Which spinner to use?
        switch (iIndex)
        {
        case 0:
            iSpnr = 1;
            break;
        case 1:
            iSpnr = 3;
            break;
        }
        // Start the thread, passing a pointer to the spinner
        m_pSpinThread[iIndex] = AfxBeginThread(ThreadFunc,
            (LPVOID)&m_cSpin[iSpnr]);
    }
}
