// GetTaxForPurchase.h : Declaration of the CGetTaxForPurchase

#pragma once
#include "resource.h"       // main symbols
#include "TaxCalculator.h"


// IGetTaxForPurchase
[
	object,
	uuid("EE0378A3-1D49-4E61-8349-5197DDA85474"),
	dual,	helpstring("IGetTaxForPurchase Interface"),
	pointer_default(unique)
]
__interface IGetTaxForPurchase : IDispatch
{
	[id(1), helpstring("method GetPurchaseTaxes")] HRESULT GetPurchaseTaxes([in] FLOAT fPurchaseAmt, [in] BSTR* bstrCategory, [out] FLOAT* pfTax);
};



// CGetTaxForPurchase

[
	coclass,
	threading("apartment"),
	vi_progid("TaxCalculations.GetTaxForPurchase"),
	progid("TaxCalculations.GetTaxForPurchase.1"),
	version(1.0),
	uuid("DB1C1BDC-11F4-44A7-85A4-EF4A4BEE4CE2"),
	helpstring("GetTaxForPurchase Class")
]
class ATL_NO_VTABLE CGetTaxForPurchase : 
	public IGetTaxForPurchase
{
private:
    TaxCalcs::CTaxCalculator* m_pTaxCalc;
public:
	CGetTaxForPurchase()
	{
	    // Initialize the pointer to the calculation module
		m_pTaxCalc = new TaxCalcs::CTaxCalculator();
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
        delete m_pTaxCalc;
	}

public:

	STDMETHOD(GetPurchaseTaxes)(FLOAT fPurchaseAmt, BSTR* bstrCategory, FLOAT* pfTax);
};

